package shooting;
import java.awt.*;
import javax.swing.ImageIcon;

/**
* Bullet Class
* Movement, draw methods
*/
public class Bullet extends GameObject
{
	double direction;
	double speed; //general movement speed
	double speedX; //horizontal speed
	double speedY; //vertical speed
	Image image, image2; //hold the loaded images in memory
	int type; //type of bullet
	
	/**
	 * Constructor
	 */
	Bullet()
	{
		//Initialization(False)
		active = false;
	}
	
	/**
	 * Movement declaration. Called once for each main loop.
	 */
	public void move()
	{
		x += speedX;
		y += speedY;
		
		if ((x < 0)||(500 < x)||(y < 0)||(500 < y))  // 500 x 500 display size
			active = false;
	}	
	
	/**
	 * draw method
	 * called once for each main loop.
	 * @param g graphic handler
	 */

	private void loadImage() 
	{
	   ImageIcon icon = new ImageIcon(getClass().getResource("bullet.png"));
	   image = icon.getImage();
	
	   ImageIcon icon2 = new ImageIcon(getClass().getResource("bullet3.png"));
	   image2 = icon2.getImage();
	}
	
	public void draw(Graphics g)
	{
		if (type == 0)
		   	g.drawImage(image,(int)x-3,(int)y-3,null);		   
		else 
			g.drawImage(image2,(int)x-3,(int)y-3,null);
	}
	
	/**
	 * activate the instance.
	 * initialization is done here too.
	 * @param ix x coordinate where the object is produced
	 * @param iy y coordinate where the object is produced
	 * @param idirection direction in degrees(0~360)
	 * @param ispeed speed in pixels
	 */
	public void activate(double ix, double iy, double idirection, double ispeed, int type)
	{
		x = ix;
		y = iy;
		direction = idirection;
		speed = ispeed;
		active = true;			//Activate the bullet instance
		this.type = type;
		loadImage();
		
		//Convert polar coordinate(speed & direction) to x-y speed for better performance
		double radian;
		radian = Math.toRadians(direction);	//Convert degree to radiant
		speedX = speed * Math.cos(radian);
		speedY = speed * Math.sin(radian);
	}

	/**
	 * Radiant fire
	 */
	//shooting radially
	public static void FireRound(double x, double y)
	{
		for (int i = 0; i < 360; i+=72)  // i linked to direction
		{
			ObjectPool.newBullet(x, y, i, 3, 1);
			// (x coord, y coord, idirection, speed, type)
		}
	}

	//Lock on player and shoot
	public static void FireAim(double x, double y, Player player)
	{
		double degree = Math.toDegrees(Math.atan2(player.y - y, player.x - x));
		ObjectPool.newBullet(x, y, degree, 4, 0);
		ObjectPool.newBullet(x, y, degree+20, 4, 0);
		ObjectPool.newBullet(x, y, degree-20, 4, 0);
	}
}


