package shooting;
import java.awt.*;

import javax.swing.ImageIcon;

/**
*Enemy Class<p>
*Movement, draw methods
*/
public class Enemy extends GameObject
{
	//Enemy life time
	int counter = 0;
	//Hit point
	int hitpoint;
	//Types of Enemy
	int type;
	//ishit Flag
	boolean ishit = false;
	//Reference to player instance
	Player player;
	//startshoot flag
	boolean startshoot;
	int shootnum; //number of pellets shot
	Image image, image2, image3, image4; //hold the loaded images in memory

	/**
	 * Constructor
	 * @param Pass the player's instance, for recognizing player's location.
	 */
	Enemy(Player iplayer)
	{
		//Detect player
		player = iplayer;
		//Initialization(False)
		active = false;
	}

	/**
	 * activate the instance.
	 * initialization is done here too.
	 * @param ix x coordinate where the object is produced
	 * @param iy y coordinate where the object is produced
	 */
	public void activate(double ix, double iy)
	{
		x = ix;
		y = iy;
		type = (int)(Math.random()+0.5);
		active = true;			//Activate the bullet instance
		hitpoint = Level.getLevel()*4 + Game.difficulty*Level.getLevel(); //increases enemy hitpoints with level
		counter = 0;
		shootnum = Level.getLevel(); //increases the number of bullets with a new level
		startshoot = false;
		loadImage();
	}

	/**
	 * Behavior of enemy when it is hit by player's bullet
	 */
	public void hit()
	{
		//Decrease hitpoint
		hitpoint--;
		ishit = true;
		if (hitpoint < 0)
		{
			//Score depends on enemy kind
			switch(type)
			{
				case 0:
					Score.addScore(10*Game.difficulty);
					break;
				case 1:
					Score.addScore(20*Game.difficulty);
					break;
				default:
			}
			//Add to Score

			//Produce explosion particle
			ObjectPool.newParticle(x, y, 45, 2);
			ObjectPool.newParticle(x, y, 135, 2);
			ObjectPool.newParticle(x, y, 225, 2);
			ObjectPool.newParticle(x, y, 315, 2);
			if ((int)(Math.random()+0.5)==0) //chance of dropping a booster on death
			{
				ObjectPool.newBooster(x, y);
			}
			active = false;
		}
	}
	
	/**
	 * 
	 */
	public void move()
	{
		//Differentiate by enemy kinds
		switch(type)
		{
			case 0:
				move_enemy0();
				break;
			case 1:
				move_enemy1();
				break;
			default:
		}
	}
	
	/**
	 * Enemy1 movement
	 */
	void move_enemy0()
	{
		counter++;
		
		//Movement behavior changes based on hitpoints
		if (y < 250)
		{
			y++;
			//Sin wave move
			if (hitpoint>1)
				x += Math.sin(y / 20);
			else 
			{	x+=Math.cos(y/50);  // longer wave
            	y=y+1.5;
			}
		}	     
	    else
	    {
	    	x++;
	    	if (hitpoint>1)
				x += Math.sin(y / 20);
			else 
			{	x+=Math.cos(y/50);  // longer wave
            	y=y+1.5;
			}	 			
			y += Math.sin(x / 20);
		
	    }
		
		//Deactivate instance when it is out of screen.
		if ( (x < 0)||(500 < x)||(y < 0)||(500 < y) ) 
		{
			active = false;
		}
		
		//Shoot frequency
		if ((counter%(60-Game.difficulty*5))==0)
		{
			Bullet.FireRound(x, y);
		}
	}

	/**
	 * Enemy2 movement
	 */
	void move_enemy1()
	{
		counter++;
		double p = 100 + Level.getLevel()*10;	//Time until stabilize
		double q = 200;	//Stabilize position
		//Quadratic Formula for movement pattern
	    if (hitpoint>2)
            y = (-q / Math.pow(p,2) * Math.pow((counter - p), 2) + q);
        else
            y = (-q / Math.pow(p,2) * 1.25 * Math.pow((counter - p), 2) + q);

		//Deactivate when it is out of screen
		if ( (-30 > y) )
		{
			active = false;
		}
		
		//Shoot frequency
		if ((counter%60==0))
		{
			//Active startshoot flag
			startshoot = true;
		}
		
		//Number of bullets depends on current level.
		if (startshoot)
		{
			if (((counter%5)==0)&&(shootnum>(1-Game.difficulty)))
			{
				Bullet.FireAim(x, y, player);
				shootnum--;
			}
		}
	}
	
	/*void move_enemy1()
	{
		counter++;	
		int count;
		Random random = new Random();
		if(counter % 30 == 0)
		{
			x+=random.nextInt(100);
			y+=+random.nextInt(250);
		}
		
			
		
		

		//Deactivate when it is out of screen
		if ( (-30 > y) )
		{
			active = false;
		}
		
		//Shoot frequency
		if ((counter%60)==0)
		{
			//Active startshoot flag
			startshoot = true;
		}
		
		//Number of bullets depends on current level.
		if (startshoot)
		{
			if (((counter%5)==0)&&(shootnum>0))
			{
				Bullet.FireAim(x, y, player);
				shootnum--;
			}
		}
	}*/
	
	
	/**
	 * Draw method
	 * Called for each main loop.
	 * @param g graphic handler
	 */
	
	 private void loadImage() {
	        ImageIcon icon = new ImageIcon(getClass().getResource("ufo.png"));
	        image = icon.getImage();
	        ImageIcon icon2 = new ImageIcon(getClass().getResource("enemy2.gif"));
	        image2 = icon2.getImage();
	        ImageIcon icon3 = new ImageIcon(getClass().getResource("ufohit.png"));
	        image3 = icon3.getImage();
	        ImageIcon icon4 = new ImageIcon(getClass().getResource("enemy2hit.gif"));
	        image4 = icon4.getImage();
	        
	   }
	
	public void draw(Graphics g)
	{
		//Color change when enemy is hit(Orange)
		if (ishit  && type == 0)
			g.drawImage(image3,(int)x-16,(int)y-16,null);
		else if (ishit && type == 1)
			g.drawImage(image4,(int)x-16,(int)y-16,null);
	
		else
		{
			switch(type) //drawing different enemies based on the type
			{
				case 0:
					g.drawImage(image,(int)x-16,(int)y-16,null);
					break;
				case 1:
					g.drawImage(image2,(int)x-16,(int)y-16,null);
					break;
				default:
			}
		}
		ishit = false;
	}
}


