package shooting;
import java.awt.event.*;
import java.sql.SQLException;

import javax.swing.*;



/**
*Game Class
*Frame begins here
*Create Game Interface
*/
public class Game extends JFrame
{
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	protected JMenuBar menuBar = new JMenuBar();
    protected JMenuItem submenu1 = new JMenuItem();
    protected JMenuItem showscores = new JMenuItem();
    protected JMenuItem about = new JMenuItem();
    public static int difficulty = 1;
	/**
	 * Main Class
	 */
    
    /**Action listeners for the menu items */
    
  //Showing high scores to the player
    protected class ShowScoresActionListener implements ActionListener
    {
        public void actionPerformed(ActionEvent e)
        {
        	 try {
				Database.DisplayHighScores();
			} catch (SQLException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}
        
        }    
    }
    
    //describing the nature of the game
    protected class AboutActionListener implements ActionListener
    {
        public void actionPerformed(ActionEvent e)
        {
        	 JOptionPane.showMessageDialog(null,  "Use arrow keys to move and space bar to shoot. " +
        	 		"\nShoot the bad aliens, collect boosters, don't get hit by enemy bullets! " +
        	 		"\nDifficulty setting increases enemy shot frequency, their hp and points for killing them."+
        	 		"\nHealth packs increase the player's health that is displayed in the lower left corner." +
        	 		"\nGun booster gives you 30 rounds of more damaging ammo." +
        	 		"\nNuclear Charge booster destroys all enemies on the screen, press Z to activate." +
        	 		"\nYou can collect multiple charges, they are displayed in the lower right corner." +        	 		
        	 		"\n\nCreated by Jun Leon Deng, Dennis DeeJay Kalbarczyk and Alex Rozenfeld!", "About", JOptionPane.QUESTION_MESSAGE);
        }    
    }
    
    //closes the game 
    protected class CloseGameActionListener implements ActionListener
    {
        public void actionPerformed(ActionEvent e)
        {
        	  dispose(); //closes the application
        }    
    }
    
    //sets difficulty to level 1
    protected class Difficulty1ActionListener implements ActionListener
    {
        public void actionPerformed(ActionEvent e)
        {
        	if (MyCanvas.scene == MyCanvas.SCENE_TITLE)
        	{
        	difficulty = 1;      
        	JOptionPane.showMessageDialog(null,  "Difficulty is set to Easy.", "Difficulty", JOptionPane.INFORMATION_MESSAGE);
        	}
        	else
        		JOptionPane.showMessageDialog(null,  "Can't change difficulty in the middle of the game!", "Difficulty", JOptionPane.WARNING_MESSAGE);
        		
        }    
    }
    
    //sets difficulty to level 2
    protected class Difficulty2ActionListener implements ActionListener
    {
        public void actionPerformed(ActionEvent e)
        {
        	if (MyCanvas.scene == MyCanvas.SCENE_TITLE)
        	{
        	 difficulty = 2;     
        	 JOptionPane.showMessageDialog(null,  "Difficulty is set to Medium.", "Difficulty", JOptionPane.INFORMATION_MESSAGE);
        	}
        	else
        		JOptionPane.showMessageDialog(null,  "Can't change difficulty in the middle of the game!", "Difficulty", JOptionPane.WARNING_MESSAGE);
        }    
    }
    
    //sets difficulty to level 3
    protected class Difficulty3ActionListener implements ActionListener
    {
        public void actionPerformed(ActionEvent e)
        {
        	if (MyCanvas.scene == MyCanvas.SCENE_TITLE)
        	{
        	 difficulty = 3;
        	 JOptionPane.showMessageDialog(null,  "Difficulty is set to Hard.", "Difficulty", JOptionPane.INFORMATION_MESSAGE);
        	}
        	else
        		JOptionPane.showMessageDialog(null,  "Can't change difficulty in the middle of the game!", "Difficulty", JOptionPane.WARNING_MESSAGE);
        }    
    }
    
    
	public static void main(String args[]) 
	{
		//Create frame
		new Game();
	}
	
	/**
	 * Constructor(No argument required)
	 */
	Game()
	{
		//*** Initialize the window
		//Title
		super("Shooting Game");

		//Close Button Implementation
		addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent evt) {
                System.exit(0);
            }
        });
	
		
		
		setSize(500, 500);		//Window size
		this.setResizable(false);
		setLocationRelativeTo(null); //centering in the middle of the screen
		//creating and adding menus
        JMenu menu = new JMenu("Options");
        submenu1 = new JMenu("Difficulty Level");
        showscores = new JMenuItem("Show High Scores");
        about = new JMenuItem("About");  
        JMenuItem closeGame = new JMenuItem("Exit Game");
        JMenuItem difficulty1 = new JMenuItem("Easy");
        JMenuItem difficulty2 = new JMenuItem("Medium");
        JMenuItem difficulty3 = new JMenuItem("Hard");          
        
        //adding submenus to the main menu option
        menu.add(submenu1);
        menu.add(showscores);
        menu.add(about);
        menu.add(closeGame);        
        submenu1.add(difficulty1);
        submenu1.add(difficulty2);
        submenu1.add(difficulty3);
        
        //adding the menu to the JMenuBar
        menuBar.add(menu);
        
        //adding the menuBar to JFrame
        setJMenuBar(menuBar);
        
        //adding event handlers                
        showscores.addActionListener(new ShowScoresActionListener());
        about.addActionListener(new AboutActionListener());
        closeGame.addActionListener(new CloseGameActionListener());
        difficulty1.addActionListener(new Difficulty1ActionListener());
        difficulty2.addActionListener(new Difficulty2ActionListener());
        difficulty3.addActionListener(new Difficulty3ActionListener());        

		//*** Initialize Canvas
		MyCanvas mc = new MyCanvas();
		add(mc);				//Add Canvas to Frame
		setVisible(true);		//Visualize Window
		//Initialize Game Data
		mc.init();
		//Create thread
		mc.initThread();
	}
}

