package shooting;

import java.io.File;
import java.io.IOException;
import java.net.MalformedURLException;

import javax.sound.midi.InvalidMidiDataException;
import javax.sound.midi.MidiSystem;
import javax.sound.midi.MidiUnavailableException;
import javax.sound.midi.Sequence;
import javax.sound.midi.Sequencer;


/**
*	Level Management<p>
*	Increases one each 500 frames<br>
*	Affects enemy production frequency and enemy bullets' number
*	*Important
*		-This class needs to be modified to be score based instead of time based
*/
public class Level
{
	static int level;
	static Sequence sequence;
	static Sequencer sequencer;
	/**
	 * Return current level
	 * @return level(0-8)
	 */
	public static int getLevel()
	{
		return level;
	}
	
	/**
	 * Increase a level
	 */
	public static void addLevel()
	{
		//Maximum is 8
		if (level < 8)
		{
			level++;
			try {
				sequencer.stop(); //stopping previous track
				int random = (int) ( 0.9 + Math.random()*8); //playing one of the 7 music files based on random number
				switch (random)
				{
				case 1:			
					 sequence = MidiSystem.getSequence(new File("sound2.mid"));
					break;
				case 2:
					 sequence = MidiSystem.getSequence(new File("sound3.mid"));
					break;
				case 3:
					 sequence = MidiSystem.getSequence(new File("sound4.mid"));
					break;
				case 4:
					 sequence = MidiSystem.getSequence(new File("sound5.mid"));
					break;
				case 5:
					 sequence = MidiSystem.getSequence(new File("sound6.mid"));
					break;
				case 6:
					 sequence = MidiSystem.getSequence(new File("sound7.mid"));
					break;
				case 7:
					 sequence = MidiSystem.getSequence(new File("sound8.mid"));
					break;
				default:
				}		    
		        // Create a sequencer for the sequence
		        sequencer = MidiSystem.getSequencer();
		        sequencer.open();
		        sequencer.setSequence(sequence);
		    
		        // Start playing
		        sequencer.start();
		    } catch (MalformedURLException e) { System.out.println("URL" );
		    } catch (IOException e) { System.out.println("IO" );
		    } catch (MidiUnavailableException e) { System.out.println("MIDI" );
		    } catch (InvalidMidiDataException e) { System.out.println("INVAL" );
		    }
		}
	}	
	/**
	 * Return level to zero
	 */
	public static void initLevel()
	{
		
		level = 1;
		//playing starting music
		try {
	        // From file
	        sequence = MidiSystem.getSequence(new File("sound.mid"));	    
	    
	        // Create a sequencer for the sequence
	        sequencer = MidiSystem.getSequencer();
	        if (sequencer.isOpen() == true)
				sequencer.stop();
	        sequencer.open();
	        sequencer.setSequence(sequence);
	    
	        // Start playing
	        sequencer.start();
	    } catch (MalformedURLException e) { System.out.println("URL" );
	    } catch (IOException e) { System.out.println("IO" );
	    } catch (MidiUnavailableException e) { System.out.println("MIDI" );
	    } catch (InvalidMidiDataException e) { System.out.println("INVAL" );
	    }
	}
}

