package shooting;
import java.awt.*;
import javax.swing.ImageIcon;

/**
 * Explosion Particle class
 * Movement, draw methods
*/
public class NukeGraphic extends GameObject
{
	double direction;
	double speed;
	double speedX;
	double speedY;
	int size;
	Image image;
	
	NukeGraphic()
	{
		active = false;
	}
	
	/**
	 * Implement the movement, called once per main loop
	 */
	public void move()
	{
		x += speedX;
		y += speedY;
		size--;
		
		if ( (x < 0)||(500 < x)||(y < 0)||(500 < y) )
		{
			active = false;
		}
		if (size < 0)
		{
			active = false;
		}
	}
	
	/**
	 * draw method
	 * called per main loop
	 * @param g graphic handler
	 */
	   private void loadImage() {
	        ImageIcon icon = new ImageIcon(getClass().getResource("boom5.png"));
	        image = icon.getImage();
	   }
	
	public void draw(Graphics g)
	{		
		g.drawImage(image,(int)(x-size/3),(int)(y-size/3),null);
	}
	
	//Initialization
	public void activate(double ix, double iy, double idirection, double ispeed)
	{
		x = ix;
		y = iy;
		direction = idirection;
		speed = ispeed;
		active = true;			//Activate bullet instance
		size = 30;		
		loadImage();		
		double radian;
		radian = Math.toRadians(direction);
		speedX = speed * Math.cos(radian);
		speedY = speed * Math.sin(radian);
	}
}


