package shooting;
import java.awt.*;
import javax.swing.ImageIcon;

/**
 * Player class
 * Movement, draw method

*/
public class Player extends GameObject
{
    double speed;
    int hitpoints;
    
    
	/**
	 * Constructor
	 * @param ix x coordinate
	 * @param iy y coordinate
	 * @param ispeed speed
	 */
    Image image, image2, image3, image4;
    
    public Player(int playerhitpoints, double ix, double iy, double ispeed)
    {
    	loadImage();
        x = ix;
		y = iy;
		speed = ispeed;
		hitpoints = playerhitpoints;
		active = false;
	}

    /**
     * Dummy function<p>
     * (Required since argument is different from the superclass' abstract method)
     */
    public void move()
    {
    }
    public int GetHitpoints()
    {
    	return this.hitpoints;
    }
	
	/**
	 * Movement
	 * @param mx x direction input(-1 ... +1)
	 * @param my y direction input(-1 ... +1)
	 */
	public void move(int mx, int my)
	{
		//Limit the movement within the canvas
		double postX = x + mx * speed;
		double postY = y + my * speed;
		
		if ((0 < postX)&&(postX < 500))
		{
			x = postX;
		}
		if ((0 < postY)&&(postY < 480))
		{
			y = postY;
		}
	}
	
	//loading images
   private void loadImage() {
        ImageIcon icon = new ImageIcon(getClass().getResource("fighter.gif"));
        image = icon.getImage();
        ImageIcon icon2 = new ImageIcon(getClass().getResource("healthbar.gif"));
        image2 = icon2.getImage();
        ImageIcon icon3 = new ImageIcon(getClass().getResource("atom1.png"));
        image3 = icon3.getImage();
        ImageIcon icon4 = new ImageIcon(getClass().getResource("boom2.gif"));
        image4 = icon4.getImage();
   }
	
	//draw method
	public void draw(Graphics g)
	{
		if (active)
		{
			g.drawImage(image,(int)x-30,(int)y-30,null);
			for (int i = this.GetHitpoints(); i > 0; i--)
			{
				g.drawImage(image2, i*15 ,430,null);
			}
			for (int i = Booster.atomcounter; i > 0; i--)
				g.drawImage(image3, 480-i*15, 420, null);			
		}
	}
   }
	
	

	
	
