package shooting;
import java.awt.*;

/**
 * Score class
 * Displays Score
*/
public class Score
{
	static int myscore;
	static int hiscore;
	Font scoreFont;
	
	/**
	 * Constructor
	 */
	Score()
	{
		scoreFont = new Font("sansserif", Font.PLAIN, 11);
		myscore = 0;
	}
	
	/**
	 * Draw score
	 * @param g graphic handler
	 */
	public void drawScore(Graphics g)
	{
		g.setColor(Color.white);
		g.setFont(scoreFont);
		g.drawString("Score: "+myscore, 15, 15);
		g.drawString("Level: "+Level.getLevel(), 15, 35);
	}
	
	/**
	 * Returns player's score
	 */
	
	public static int getScore()
	{
	 return myscore;
	}
	
	
	/**
	 * Draw high score
	 * @param g graphic handler
	 */
	public void drawHiScore(Graphics g)
	{
		g.setColor(Color.white);
		g.setFont(scoreFont);
		g.drawString("High Score: "+hiscore, 380, 15);
	}
	
	
	/**
	 * add to score
	 * @param gain score to be added
	 */
	public static void addScore(int gain)
	{
		myscore += gain;
	}
	
	/**
	 * High score update method<p>
	 * Update the high score when the score is higher than the previous high score
	 */
	public static void compareScore()
	{
		if (myscore > hiscore)
		{
			hiscore = myscore;
			saveScore();
		}
	}


	/**
	 * Score storing method<p>
	 * add to data.dat in binary form
	 */
	static void saveScore()
	{
//            DataOutputStream dout = new DataOutputStream(new FileOutputStream("data.dat"));
//            dout.writeInt(hiscore);
//            dout.close();
	}

	/**
	 * Read score
	 * Read from data.dat in binary form
	 */
	static void loadScore()
	{
//            DataInputStream din = new DataInputStream(new FileInputStream("data.dat"));
//            hiscore = din.readInt();
//            din.close();
	}
	
	/**
	 * *Important
	 * 		-The above two part should be modified to suit the SQL
	 */

	//InitializeScore
	public static void initScore()
	{
		myscore = 0;
	}
}


